<template>
  <button 
    :class="classType"
    @click="action"
  >
    {{ text }}
  </button>
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    text: {
      type: String,
      required: true,
    },
    action: {
      type: Function,
      required: true,
    },
    buttonType: {
      type: String,
      default: 'primary',
    },
    primaryClass: {
      type: String,
      default: '',
      required: true,
    }
  },

  computed: {
    classType(): string {
      if (this.buttonType === 'primary') {
        return 'btn bg-' + this.primaryClass + ' text-white';
      } else {
        return 'btn bg-transparent text-' + this.primaryClass + ' border border-' + this.primaryClass;
      }
    },
  },
});
</script>

<style lang="postcss">
.btn {
  @apply m-4 py-4 px-8 rounded;
}

.btn:hover {
  transition: all 0.25s ease-out;
}
</style>
